/******************************************************************/
/*									                              */
/*      Description : File writing process                        */
/*      Making Date : 2010. 05. 06					              */
/*      Affiliate   : Machine Learning Lab in SoongSil Univ       */
/*      Developer   : Sungin Park(rfchief@gmail.com)              */
/******************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "FileWriter.h"

int writeDataFile(char* filePath, int size, float data[])
{    
    FILE *out_file;
    int i = 0;
    int rowCnt = -1 + size;

    out_file = fopen(filePath, "w");
    if (out_file == NULL) {        
        return 0;
    }

    for (i = 0; i < size*size; i++) {
		if(i == rowCnt){
            fprintf(out_file, "%lf\n",data[i]);
			rowCnt = rowCnt + size;
		}else{
            fprintf(out_file, "%lf\t",data[i]); 
		}
    }
    
	fclose(out_file);    

	return 1;
}

int writeDataFileInt(char* filePath, int size, int data[])
{    
    FILE *out_file;
    int i = 0;
    
    out_file = fopen(filePath, "w");
    if (out_file == NULL) {        
        return 0;
    }

    for (i = 0; i < size; i++) {		
        fprintf(out_file, "%ld\n",data[i]);	
    }
    
	fclose(out_file);    

	return 1;
}

int writeDataFileLong(char* filePath, int size, long data)
{    
    FILE *out_file;
    
    out_file = fopen(filePath, "w");
    if (out_file == NULL) {
        fprintf(stderr,"Can not open output file\n");
        return 0;
    }

	fprintf(out_file, "%ld sec\n",data);	
	fclose(out_file); 
	
	return 1;
}

int writeeValueFile(char* filePath, int size, float data[])
{
    FILE *fp;
	int i = 0;

    if((fp=fopen(filePath,"w"))==NULL)
	{
		return 0;
	}
	
	for(i = 0; i<size; i++){
		fprintf(fp, "%10.5f\n", data[i]);	
	}

	fclose(fp);

	return 1;
}

int writeeValueFileList(char* filePath, int size1, int size2, int p, float **data)
{
    FILE *fp;
	int i = 0, j = 0, k = 0;

    if((fp=fopen(filePath,"w"))==NULL)
	{
		return 0;
	}
	
	k = p;
	for(i = 0; i<size1; i++){
		if(i == size2){
			k = p-1;
		}

		for(j = 0; j < k; j++){			
			fprintf(fp, "%10.5f\t", data[j][i]);						
		}		
		fprintf(fp, "\n");
	}

	fclose(fp);

	return 1;
}

int writeeVectorFile(char* filePath, int size, float data[])
{
    FILE *fp;
	int i = 0;

    if((fp=fopen(filePath,"w"))==NULL)
	{
		return 0;
	}
	
	for(i = 0; i<size; i++){
		fprintf(fp, "%10.5f\n", data[i]);	
	}

	fclose(fp);

	return 1;
}

int writeResultFile(char* filePath, int size, int dim, float data[])
{
    FILE *fp;
	int i = 0, j = 0;

    if((fp=fopen(filePath,"w"))==NULL)
	{
		return 0;
	}
	
	for(i = 0; i<size; i++)
	{
		for(j=0; j<dim; j++)
		{
			fprintf(fp, "%10.10f\t", data[(j*size)+i]);	
		}
		fprintf(fp, "\n");
	}

	fclose(fp);

	return 1;
}

int writeResultFileH(char* filePath, int size, int dim, float data[], char **labelData)
{
    FILE *fp;
	int i = 0, j = 0;

    if((fp=fopen(filePath,"w"))==NULL)
	{
		return 0;
	}
	
	for(i = 0; i<size; i++)
	{
		fprintf(fp, "%s\t", labelData[i]);	

		for(j=0; j<dim; j++)
		{
			fprintf(fp, "%10.5f\t", data[(j*size)+i]);	
		}
		fprintf(fp, "\n");
	}

	fclose(fp);

	return 1;
}

int writeLogFile(char* filePath, char *msg, int chkNew)
{
    FILE *fp;	

	if(chkNew == 1){
		if((fp=fopen(filePath,"w"))==NULL)
		{
			return 0;
		}
		fprintf(fp, "\tCFMDS program start\n");
		fprintf(fp, "======================================================================\n\n");	
	}else{
		if((fp=fopen(filePath,"a"))==NULL)
		{
			return 0;
		}
	}//chkNew
		
	if(chkNew == 2){
		fprintf(fp, "\n======================================================================\n\n");	
	}else{
		fprintf(fp, "\t%s\n", msg);		
	}
	fclose(fp);

	return 1;
}
