/******************************************************************/
/*									                              */
/*      Description : QSort process                               */
/*      Making Date : 2010. 05. 06					              */
/*      Affiliate   : Machine Learning Lab in SoongSil Univ       */
/*      Developer   : Sungin Park(rfchief@gmail.com)              */
/******************************************************************/
#include <stdio.h>
#include <stdlib.h> 
#include "dataStruct.h"
#include "qSort.h"

void swap(float *x,float *y)
{
   float temp;
   temp = *x;
   *x = *y;
   *y = temp;
}

void swapS(struct divDataStr *x, struct divDataStr *y)
{
   struct divDataStr temp;
   
   temp.colIdx = x->colIdx;
   temp.rowIdx = x->rowIdx;
   temp.value  = x->value;

   x->colIdx = y->colIdx;
   x->rowIdx = y->rowIdx;
   x->value = y->value;
   
   y->colIdx = temp.colIdx;
   y->rowIdx = temp.rowIdx;
   y->value = temp.value;
}

int choose_pivot(int i,int j )
{
   return((i+j) /2);
}

void quicksort(float list[],int m,int n)
{
   float key = 0.0f;
   int i,j,k;

   if( m < n)
   {
      k = choose_pivot(m,n);
      swap(&list[m],&list[k]);
      key = list[m];
  	  i = m+1;
      j = n;
      while(i <= j)
      {
         while((i <= n) && (list[i] <= key))
                i++;
         while((j >= m) && (list[j] > key))
                j--;
         if( i < j)
                swap(&list[i],&list[j]);
      }
	  // swap two elements
      swap(&list[m],&list[j]);
	  // recursively sort the lesser list
      quicksort(list,m,j-1);
      quicksort(list,j+1,n);
   }
}

void quicksortS(struct divDataStr list[],int m,int n)
{
   float key = 0.0f;
   int i,j,k;

   if( m < n)
   {
      k = choose_pivot(m,n);
	  swapS(&list[m],&list[k]);
	  key = list[m].value;
  	  i = m+1;
      j = n;
      while(i <= j)
      {
		  while((i <= n) && (list[i].value <= key))
                i++;
		  while((j >= m) && (list[j].value > key))
                j--;
         if( i < j)
                swapS(&list[i],&list[j]);
      }
	  // swap two elements
      swapS(&list[m],&list[j]);
	  // recursively sort the lesser list
      quicksortS(list,m,j-1);
      quicksortS(list,j+1,n);
   }
}

void printlist(float list[],int n)
{
   int i;
   for(i=0;i<n;i++)
      printf("%f\t",list[i]);
}

