/******************************************************************/
/*									                              */
/*      Description : Utility functions                           */
/*      Making Date : 2010. 05. 06					              */
/*      Affiliate   : Machine Learning Lab in SoongSil Univ       */
/*      Developer   : Sungin Park(rfchief@gmail.com)              */
/******************************************************************/

#include <stdio.h>
#include "utilFunc.h"
#include "memTest.h"
#include "FileWriter.h"

extern "C"
int find_index(int a[], int num_elements, int value)
{
   int i;
   for (i=0; i < num_elements; i++)
   {
	 if (a[i] == value)
	 {
	    return(value);  /* it was found */
	 }
   }
   return(-1);  /* if it was not found */
}

extern "C"
int makingDivide(int size_x, int* p, int pMax, int* dSize_x_l, int* s_f, int* s_l){
	int tempP    =  *p;
	int dSize_f  = ((int)((size_x / tempP) * 0.1f)) * 10;		
	int i        = (size_x / tempP) - dSize_f;	
	*dSize_x_l   = size_x % tempP;	
	*dSize_x_l   = *dSize_x_l + (i*tempP);
	
	if(*dSize_x_l == 0){
		*s_f = ((int)((pMax / tempP) * 0.1f)) * 10;		
		*s_l = *s_f;
		*dSize_x_l = dSize_f;
	}else{
		*s_f = ((int)(( (pMax - *dSize_x_l) / tempP) * 0.1f)) * 10;
		*s_l = *dSize_x_l;
		(*p)++;
	}	
		
	return dSize_f;

}

extern "C"
int decDivideCnt(int objSize, int* pMax, struct paramsStr params){
	int divideCnt = 0;
	int divMaxSize = 0;
	int freeMem = chkMem(params);
	char fPath[1100];
	char logMsg[1100];	

	divMaxSize = (int)(((2000*freeMem)/200)*0.1f);
	divMaxSize = divMaxSize * 10;
	printf("1st decision of matrix size : objSize = %d\tdivMaxSize = %d\n",objSize, divMaxSize);
	
	sprintf(fPath, "%s_Log.txt", params.outName);
	sprintf(logMsg, "1st decision of matrix size : objSize = %d\tdivMaxSize = %d",objSize, divMaxSize);
	writeLogFile(fPath, logMsg, 0);
	
	//CUDA  ִ ũⰡ Էµ ũ⺸  
	if(divMaxSize > objSize){
		printf("divMaxSize is bigger than objSize.\n");
		sprintf(logMsg, "divMaxSize is bigger than objSize.");
		writeLogFile(fPath, logMsg, 0);

		divideCnt = 0;
	}else{
		printf("divMaxSize is smaller than objSize.\n");		
		sprintf(logMsg, "divMaxSize is smaller than objSize.");
		writeLogFile(fPath, logMsg, 0);

		divMaxSize = (int)(((1500*freeMem)/200)*0.1f);
		divMaxSize = divMaxSize * 10;
		printf("2nd decision of matrix size : objSize = %d\tdivMaxSize = %d\n",objSize, divMaxSize);
		sprintf(logMsg, "2nd decision of matrix size : objSize = %d\tdivMaxSize = %d",objSize, divMaxSize);
		writeLogFile(fPath, logMsg, 0);
		
		if((objSize % divMaxSize) == 0){ 
			divideCnt = objSize / divMaxSize;
		}else{
			divideCnt = (objSize / divMaxSize) + 1;
		}
	}

	*pMax = divMaxSize;

	return divideCnt;
}

void errorExit(int i){	
	
	char fPath[1100];
	char logMsg[2000];

	if(i == 0){                                             //When input data reading, File open
		printf("!!!!Program terminated.\n");	
	}else if(i == 1){                                       //When cula error
		printf("!!!!Program terminated.\n");	
		culaShutdown();
	}else if(i == 2){                                       //When cublas error
		printf("!!!!Program terminated.\n");	
		cublasShutdown();
	}else if(i == 3){                                       //When the information is not match between object size parameter and the number of input data's objects   
		//printf("!!!!The number of objects is not match in input data.\n");	
		printf("!!!!Program terminated.\n");	
	}else if(i == 4){                                       //When file writing about result of CFMDS
		printf("!!!!Program terminated.\n");	
	}else if(i == -9){                                      //When parameters parsing error
		printf("!!!!Parameters have some errors, program terminated.\n");	

		sprintf(fPath, "CFMDS_Log.txt");
		sprintf(logMsg, "!!!!Parameters have some errors, program terminated.");
		writeLogFile(fPath, logMsg, 1);		
		writeLogFile(fPath, logMsg, 2);

	}else{
		printf("!!!!Program occurred errors, program terminated.\n");	
	}

	exit(1);
}

extern "C"
int parseParams(int argc, char** argv, struct paramsStr *params){
	int i = 1;		
	int s = 0, d = 0, o = 0, inc = 0;
	
	//initialize some parameters
	params->svd    = 'n';
	params->header = 'n';
	params->method = 'r';

	while ((argc > 1) && (argv[i][0] == '-'))
	{
		switch (argv[i][1])
		{
			case 's':				
				params->size = atoi(argv[++i]);
				s = 1;
				break;
			case 'd':				
				params->dimension = atoi(argv[++i]);
				d = 1;
				break;			
			case 'h':				
				params->header = *argv[++i];
				break;
			case 'e':				
				params->svd = *argv[++i];
				break;
			case 'm':				
				params->method = *argv[++i];
				break;
			case 'o':				
				params->outName = argv[++i];
				o = 1;
				break;
			case 'i':				
				params->inputName = argv[++i];
				inc = 1;
				break;
			default:
				printf("Wrong Argument: %s\n", argv[i]);
				return 0;
		}

		++i;
		argc = argc - 2;
	}

	if(s == 0 || d == 0 || o == 0 || inc == 0){
		return 0;
	}

	return 1;
}

/* Check for errors and exit if one occurred */
void checkStatus(culaStatus status, struct paramsStr params)
{
	char fPath[1100];
	char logMsg[1100];

    if(!status)
        return;

	sprintf(fPath, "%s_Log.txt", params.outName);

	if(status == culaArgumentError){
        printf("Invalid value for parameter %d\n", culaGetErrorInfo());
		sprintf(logMsg, "Invalid value for parameter %d", culaGetErrorInfo());
		writeLogFile(fPath, logMsg, 0);		
		sprintf(logMsg, "Program terminated");
		writeLogFile(fPath, logMsg, 0);		
		writeLogFile(fPath, logMsg, 2);
	}
	else{
        printf("%s\n", culaGetStatusString(status));
		sprintf(logMsg, "%s", culaGetStatusString(status));
		writeLogFile(fPath, logMsg, 0);		
		sprintf(logMsg, "Program terminated");
		writeLogFile(fPath, logMsg, 0);		
		writeLogFile(fPath, logMsg, 2);
	}

	errorExit(1);
}


/* Check for errors and exit if one occurred */
int cublasCheckStatus(cublasStatus status, struct paramsStr params)
{
	char fPath[1100];
	char logMsg[1100];

	if(status != CUBLAS_STATUS_SUCCESS){
		if (status == CUBLAS_STATUS_NOT_INITIALIZED) {
			fprintf (stderr, "!!!! CUBLAS initialization error\n");
			sprintf(fPath, "%s_Log.txt", params.outName);
			sprintf(logMsg, "!!!! CUBLAS initialization error");
			writeLogFile(fPath, logMsg, 0);		
			sprintf(logMsg, "Program terminated");
			writeLogFile(fPath, logMsg, 0);		
			writeLogFile(fPath, logMsg, 2);

			errorExit(2);			
		}else if (status != CUBLAS_STATUS_ALLOC_FAILED) {
			fprintf (stderr, "!!!! Device memory allocation error\n");
			sprintf(fPath, "%s_Log.txt", params.outName);
			sprintf(logMsg, "!!!! Device memory allocation error");
			writeLogFile(fPath, logMsg, 0);		
			sprintf(logMsg, "Program terminated");
			writeLogFile(fPath, logMsg, 0);		
			writeLogFile(fPath, logMsg, 2);

			errorExit(2);	
		}else if (status != CUBLAS_STATUS_MAPPING_ERROR) {
			fprintf (stderr, "!!!! Device access error\n");
			sprintf(fPath, "%s_Log.txt", params.outName);
			sprintf(logMsg, "!!!! Device access error");
			writeLogFile(fPath, logMsg, 0);		
			sprintf(logMsg, "Program terminated");
			writeLogFile(fPath, logMsg, 0);		
			writeLogFile(fPath, logMsg, 2);

			errorExit(2);	
		}else if (status != CUBLAS_STATUS_INTERNAL_ERROR) {
			fprintf (stderr, "!!!! Memory free error\n");
			sprintf(fPath, "%s_Log.txt", params.outName);
			sprintf(logMsg, "!!!! Memory free error\n");
			writeLogFile(fPath, logMsg, 0);		
			sprintf(logMsg, "Program terminated");
			writeLogFile(fPath, logMsg, 0);		
			writeLogFile(fPath, logMsg, 2);

			errorExit(2);	
		}else if (status != CUBLAS_STATUS_INVALID_VALUE) {
			fprintf (stderr, "!!!! Device access error\n");
			sprintf(fPath, "%s_Log.txt", params.outName);
			sprintf(logMsg, "!!!! Device access error");
			writeLogFile(fPath, logMsg, 0);		
			sprintf(logMsg, "Program terminated");
			writeLogFile(fPath, logMsg, 0);		
			writeLogFile(fPath, logMsg, 2);

			errorExit(2);	
		}
	}

	return 1;
}//cublasCheckStatus
